/***************************************************************************
 *                          Zanoza Modeler v2.x                            *
 *      This is unpublished propietary source code of Zanoza Software.     *
 *      The copyright notice does not evidence any actual or intended      *
 *                    publication of such source code.                     *
 *                                                                         *
 *                Copyright (c) 2002-2008 Zanoza Software.                 *
 *                                                                         *
 *                        All rights reserved.                             *
 ***************************************************************************
 *--------------------------------------------------------------------------
 * @author:   Oleg Melashenko
 *--------------------------------------------------------------------------
 * @purpose:  Declaration of the class ITexture
 *   Texture interface
 *--------------------------------------------------------------------------
 * @created: Monday, July 07, 2003 17:32:49
 */

#if !defined(ITexture_h_included)
#define ITexture_h_included
//forward declaration of this class might require
namespace rend
{ class ITexture; class CTextureCol; };
#include <zmodeler.h>
#include <rend/renderTypes.h>

namespace rend
{
  
  class ITexture : public ZUnknown
  {
  public:
    virtual ZRESULT getTitle(ZString& strName)=0;
    virtual ZRESULT setTitle(ZString strName)=0;
    virtual ZRESULT getPathName(ZString& szPathName)=0;
    virtual ZRESULT setPathName(LPCTSTR pszPathName)=0;
    virtual ZRESULT setContainerName(ZString strName)=0;
    virtual ZRESULT getContainerName(ZString& strName)=0;
    virtual ZRESULT setGroup(eTextureGroup grp)=0;
    virtual ZRESULT getGroup(eTextureGroup& grp)=0;
    virtual ZRESULT getSize(long& nWidth, long& nHeight)=0;
    virtual ZRESULT setSize(long nWidth, long nHeight)=0;
    virtual ZRESULT getFormat(DWORD& dwFormat)=0;
    virtual ZRESULT setFormat(DWORD dwFormat)=0;
    virtual ZRESULT getBaseTexture(IBaseTexture** ppBase)=0;
    virtual ZRESULT setBaseTexture(IBaseTexture* pBase)=0;
    virtual ZRESULT hasAlpha(void)=0;
    virtual ZRESULT getColorKey(bool& bOn, ZColor* colorLow, ZColor* colorHigh)=0;
    virtual ZRESULT setColorKey(bool bOn, ZColor colorLow, ZColor colorHigh)=0;
  
  };//class ITexture
  
  //
  // collection template
  //
  class CTextureCol : public ZUnknown,
      public ZIntrCollection<ITexture>
  {
  public:
    INTERFACE_FUNCTIONS_DEFAULT(CTextureCol)
  };//class CTextureCol
};//rend

#endif
